unit GetArchitecture;
interface
uses  Windows;

const
  {These constants are used by the GetSystemInfo function,
   but they are not defined in the Delphi source code, so we must do it ourselves}
  PROCESSOR_INTEL_386 = 386;
  PROCESSOR_INTEL_486 = 486;
  PROCESSOR_INTEL_PENTIUM = 586;
  PROCESSOR_MIPS_R4000 = 4000;
  PROCESSOR_ALPHA_21064 = 21064;

  PROCESSOR_ARCHITECTURE_INTEL = 0;
  PROCESSOR_ARCHITECTURE_MIPS = 1;
  PROCESSOR_ARCHITECTURE_ALPHA = 2;
  PROCESSOR_ARCHITECTURE_PPC  = 3;
  PROCESSOR_ARCHITECTURE_UNKNOWN = $FFFF;

var
  MySysInfo           :TSystemInfo;   // holds the system information
  ProcessorType       :string;
  Architecture        :string;
  NumberOfProcessors  :Integer;
implementation

begin

  {retrieve information about the system}
  GetSystemInfo(MySysInfo);
  NumberOfProcessors:=MySysInfo.dwNumberOfProcessors;
  ProcessorType:='Unknown';
  case MySysInfo.wProcessorArchitecture of
    PROCESSOR_ARCHITECTURE_INTEL: begin
      Architecture := 'Intel Processor Architecture';

      case MySysInfo.dwProcessorType of
        PROCESSOR_INTEL_386:     ProcessorType:= '80386';
        PROCESSOR_INTEL_486:     ProcessorType:= '80486';
        PROCESSOR_INTEL_PENTIUM: ProcessorType:= 'Pentium';
      end;
    end;
    PROCESSOR_ARCHITECTURE_MIPS:
      Architecture := 'MIPS Processor Architecture';
    PROCESSOR_ARCHITECTURE_ALPHA:
      Architecture := 'DEC ALPHA Processor Architecture';
    PROCESSOR_ARCHITECTURE_PPC:
      Architecture := 'PPC Processor Architecture';
    PROCESSOR_ARCHITECTURE_UNKNOWN:
      Architecture := 'Unknown Processor Architecture';
  end;

end.
